Attribute VB_Name = "Module1"

'Test Printer Status (1)

'Acknowledgements : This program has been written making extensive use of the
'Merrion article http://www.merrioncomputing.com/Programming/PrintStatus.htm
'It has also benefited from the contributors to VBForums thread # 733849
'http://www.vbforums.com/showthread.php?t=733849&goto=newpost - especially the code
'suggested by "Bonnie West"
'The code has been developed and tested thus far only under Win XP.

'Program updated 17 Sept. 2013 by C.A. Moore


Option Explicit

Dim PRINTERFOUND As Long

Dim GETPRINTER As Long

Dim BUFFER() As Long

Dim pbSizeNeeded As Long

Dim PRINTERINFO As PRINTER_INFO_2

Dim N As Long

Dim M As Long

Dim CHAR As String

Dim prnPrinter As Printer

Dim BUF13BINARY As String

' Note : PRINTERREADY as an Integer variable is Dim'd
'"Public PRINTERREADY As Integer" at Form1 Option Explicit


Private Type PRINTER_INFO_2

   pServerName As String
   pPrinterName As String
   pShareName As String
   pPortName As String
   pDriverName As String
   pComment As String
   pLocation As String
   pDevMode As Long
   pSepFile As String
   pPrintProcessor As String
   pDatatype As String
   pParameters As String
   pSecurityDescriptor As Long
   Attributes As Long
   Priority As Long
   DefaultPriority As Long
   StartTime As Long
   UntilTime As Long
   Status As Long
   JobsCount As Long
   AveragePPM As Long
   
End Type


Private Declare Function GetPrinterApi Lib "winspool.drv" Alias "GetPrinterA" (ByVal hPrinter As Long, ByVal Level As Long, BUFFER As Long, ByVal pbSize As Long, pbSizeNeeded As Long) As Long

Private Declare Function OpenPrinterW Lib "winspool.drv" (ByVal pPrinterName As Long, ByRef phPrinter As Long, Optional ByVal pDefault As Long) As Long

Private Declare Function ClosePrinter Lib "winspool.drv" (ByVal hPrinter As Long) As Long

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)


Public Function StringFromPointer(lpString As Long, lMaxLength As Long) As String

'this service function extracts a string (sRet) when fed with a pointer (lpstring)
'from a buffer

  Dim sRet As String
  Dim lret As Long

  If lpString = 0 Then
  
    StringFromPointer = ""
    
    Exit Function
    
  End If

  '\\ Pre-initialise the return string...
  sRet = Space$(lMaxLength)
  
  CopyMemory ByVal sRet, ByVal lpString, ByVal Len(sRet)
  
  If Err.LastDllError = 0 Then
  
    If InStr(sRet, Chr$(0)) > 0 Then
    
      sRet = Left$(sRet, InStr(sRet, Chr$(0)) - 1)
      
    End If
    
  End If

  StringFromPointer = sRet

End Function



Public Function IsPrinterReady(ByRef PrinterName As String)

    Form1.PRINTERREADY = 9
    
    Form1.Label2.Caption = PrinterName      'show printer name at form1

    'first select the named printer and check if it is installed

    For Each prnPrinter In Printers
    
        CHAR = prnPrinter.DeviceName
         
        If CHAR = PrinterName Then
        
            Set Printer = prnPrinter   'sets this as printer
            
            Form1.PRINTERREADY = 1
            
        End If
    
    Next
        
    If Form1.PRINTERREADY = 9 Then GoTo Line1000  'exit. named printer not installed
        
    
    Dim hPrinter As Long
    
    PRINTERFOUND = 0
    
    Form1.PRINTERREADY = 0

    PRINTERFOUND = OpenPrinterW(StrPtr(PrinterName), hPrinter)
    '(OpenPrinterW(ByVal pPrinterName As Long, ByRef phPrinter As Long) As Long)

    If PRINTERFOUND = 0 Then                'ie. printer not found
    
        Form1.PRINTERREADY = 0
        
        ClosePrinter (hPrinter)
        
        GoTo Line1000
        
    End If
    
    
    'If we get here named printer was found and accessed and its hPrinter handle is
    'known
     
     ReDim Preserve BUFFER(0 To 1) As Long
   
     GETPRINTER = GetPrinterApi(hPrinter, 2&, BUFFER(0), UBound(BUFFER), pbSizeNeeded)
       
     ReDim Preserve BUFFER(0 To (pbSizeNeeded / 4) + 3) As Long
     
     GETPRINTER = GetPrinterApi(hPrinter, 2&, BUFFER(0), UBound(BUFFER) * 4, pbSizeNeeded)
    
        If GETPRINTER = 0 Then              'ie. some problem with printer access

            Form1.PRINTERREADY = 0
            
            ClosePrinter (hPrinter)
        
            GoTo Line1000
        
        End If
    
        'If we get here then GETPRINTER = 1, ie. printer found and accessed OK
        
            With PRINTERINFO '\\ This variable is of type PRINTER_INFO_2
            'These quantities are defined here because the Merrion article
            'so specifies. However they are not used by this program, and most
            'have been found to be void
            
                .pServerName = StringFromPointer(BUFFER(0), 1024)
                .pPrinterName = StringFromPointer(BUFFER(1), 1024)
                .pShareName = StringFromPointer(BUFFER(2), 1024)
                .pPortName = StringFromPointer(BUFFER(3), 1024)
                .pDriverName = StringFromPointer(BUFFER(4), 1024)
                .pComment = StringFromPointer(BUFFER(5), 1024)
                .pLocation = StringFromPointer(BUFFER(6), 1024)
                .pDevMode = BUFFER(7)
                .pSepFile = StringFromPointer(BUFFER(8), 1024)
                .pPrintProcessor = StringFromPointer(BUFFER(9), 1024)
                .pDatatype = StringFromPointer(BUFFER(10), 1024)
                .pParameters = StringFromPointer(BUFFER(11), 1024)
                .pSecurityDescriptor = BUFFER(12)
                .Attributes = BUFFER(13)
                .Priority = BUFFER(14)
                .DefaultPriority = BUFFER(15)
                .StartTime = BUFFER(16)
                .UntilTime = BUFFER(17)
                .Status = BUFFER(18)
                .JobsCount = BUFFER(19)
                .AveragePPM = BUFFER(20)
  
            End With

                    'This next code is for interest and program development only.
                    'It writes into List1 the value of each buffer 1 - 20
                    'To by-pass it, add a "Go To Line15" statement at this point.
                
                    Form1.List1.Clear
                    
                    N = 0
                
Line5:
                    On Error GoTo Line15
                    
                    Form1.List1.AddItem "Buffer No. " & N & "  Buffer Value = " & BUFFER(N)
                
                    N = (N + 1)
                    
                    If N = 21 Then GoTo Line15
                
                    GoTo Line5
                   
                   
                   
                   'Now to convert the decimal value of Buffer(13) into a binary
                   'bit pattern and store this in string variable BUF13BINARY
Line15:            'and show Buffer(13) value as a binary bit pattern at Form1.Label1
                    
                    N = BUFFER(13)

                    BUF13BINARY = ""
                    
                    M = 65536
                   
                    Do
                        If N < M Then
                        
                            BUF13BINARY = BUF13BINARY & "0"
                            
                        Else
                        
                            BUF13BINARY = BUF13BINARY & "1"
                            
                            N = (N - M)
                            
                        End If
                        
                        If M = 1 Then Exit Do
                        
                        M = Round((M / 2), 0)
                        
                    Loop

                    
Line10: 'BUF13BINARY is now the 17 bit binary value of Buffer(13)
        'eg. 00000011000100010

        Form1.Label1.Caption = BUF13BINARY  'display this binary value at form 1
        
' For info, these are the listed meanings of the 16 Attribute bits
' PRINTER_ATTRIBUTE_QUEUED            0x00000001    Decimal value = 1    (LSB)
' PRINTER_ATTRIBUTE_DIRECT            0x00000002    Decimal value = 2
' PRINTER_ATTRIBUTE_DEFAULT           0x00000004    Decimal value = 4
' PRINTER_ATTRIBUTE_SHARED            0x00000008    Decimal value = 8
' PRINTER_ATTRIBUTE_NETWORK           0x00000010    Decimal value = 16
' PRINTER_ATTRIBUTE_HIDDEN            0x00000020    Decimal value = 32
' PRINTER_ATTRIBUTE_LOCAL             0x00000040    Decimal value = 64
' PRINTER_ATTRIBUTE_ENABLE_DEVQ       0x00000080    Decimal value = 128
' PRINTER_ATTRIBUTE_KEEPPRINTEDJOBS   0x00000100    Decimal value = 256
' PRINTER_ATTRIBUTE_DO_COMPLETE_FIRST 0x00000200    Decimal value = 512
' PRINTER_ATTRIBUTE_WORK_OFFLINE      0x00000400    Decimal value = 1024
' PRINTER_ATTRIBUTE_ENABLE_BIDI       0x00000800    Decimal value = 2048
' PRINTER_ATTRIBUTE_RAW_ONLY          0x00001000    Decimal value = 4196
' PRINTER_ATTRIBUTE_PUBLISHED         0x00002000    Decimal value = 8392
' PRINTER_ATTRIBUTE_FAX               0x00004000    Decimal value = 16784
' PRINTER_ATTRIBUTE_TS                0x00008000    Decimal value = 33568 (MSB)

        
        'we now examine the value of the seventh binary bit in BUF13BINARY (1024)
        'this has meaning WORK OFFLINE

        If Mid$(BUF13BINARY, 7, 1) = "0" Then Form1.PRINTERREADY = 1  'READY
        
        If Mid$(BUF13BINARY, 7, 1) = "1" Then Form1.PRINTERREADY = 0  'OFFLINE
        
        If Mid$(BUF13BINARY, 3, 1) = "1" Then Form1.PRINTERREADY = 2  'FAX
        
        If Mid$(BUF13BINARY, 13, 1) = "1" Then Form1.PRINTERREADY = 3 'Network Ptr.
        
              
Line1000:
    
End Function
